"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _syntaxParser = require("./syntax-parser");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var LONGEST_LOOP = 99;

var Core = /*#__PURE__*/function () {
  function Core() {
    var _this = this;

    _classCallCheck(this, Core);

    this._runningPtext;
    this._runningFileId;
    this._callbacks;
    this._interval;
    this._isPaused;
    this._timerCallbacks = {
      interval: function interval(remainingSec, durationSec, stepNos) {
        _this._callbacks.interval && _this._callbacks.interval(remainingSec, durationSec, stepNos, _this._runningPtext);
      },
      step: function step() {
        return _this._callbacks.step && _this._callbacks.step(_this._runningPtext);
      }
    };
  }

  _createClass(Core, [{
    key: "findAndStartTimer",
    value: function findAndStartTimer(text, fileId) {
      var callbacks = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      this._callbacks = callbacks;

      var ptext = this._findPomodoroText(text, fileId);

      if (this._runningPtext && ptext.operator === this._runningPtext.operator && ptext.syntax === this._runningPtext.syntax && ptext.content === this._runningPtext.content && fileId === this._runningFileId) {
        return;
      }

      if (ptext) {
        if (!this._runningPtext || ptext.content !== this._runningPtext.content || ptext.syntax !== this._runningPtext.syntax || fileId !== this._runningFileId) {
          if (this._interval) {
            clearInterval(this._interval);
            this._interval = null;
            callbacks.cancel && callbacks.cancel();
          }

          callbacks.start && callbacks.start(ptext);

          this._startTimer(ptext.ast, this._timerCallbacks).then(function () {
            return callbacks.finish && callbacks.finish(ptext);
          });
        }

        this._runningPtext = ptext;
        this._runningFileId = fileId;

        if (ptext.operator === '-') {
          this._isPaused = true;
        } else if (this._isPaused) {
          this._isPaused = false;
        }
      } else {
        if (!this._runningFileId || fileId === this._runningFileId) {
          this._runningPtext = null;

          this._clearTimer();

          callbacks.cancel && callbacks.cancel();
        }
      }
    }
  }, {
    key: "_findPomodoroText",
    value: function _findPomodoroText(text, id) {
      var lines = text.split('\n');
      var lineNumber = 0;

      var _iterator = _createForOfIteratorHelper(lines),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var line = _step.value;
          var found = line.match(/^ *(?:- |\* |)(?:\[ \] |)\[(-|)([p0-9() ]+)\] *(.+)/);

          if (found) {
            var syntax = found[2];

            if (syntax.trim().length === 0) {
              continue;
            }

            var ast = (0, _syntaxParser.parse)(syntax);

            if (ast.length === 0) {
              return false;
            }

            var operator = found[1];
            var content = found[3];
            var checkboxRegex = /^ *(?:-|\*) \[/g;
            var checkboxOffset = checkboxRegex.test(line) ? checkboxRegex.lastIndex : 0;
            return {
              id: id,
              line: lineNumber,
              checkboxOffset: checkboxOffset,
              operator: operator,
              syntax: syntax,
              ast: ast,
              content: content
            };
          }

          lineNumber++;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return false;
    }
  }, {
    key: "_startTimer",
    value: function _startTimer(ast, callbacks) {
      var results = [];

      this._convertToPromises(ast, callbacks, results);

      return results.reduce(function (p, n, i) {
        return p.then(function () {
          if (0 < i && i < results.length) {
            callbacks.step();
          }

          return n();
        });
      }, Promise.resolve());
    }
  }, {
    key: "_convertToPromises",
    value: function _convertToPromises(ast, callback, results) {
      var _this2 = this;

      var stepNos = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

      if (ast.length === 0) {
        return;
      }

      ast = JSON.parse(JSON.stringify(ast));
      var timer = ast.shift();

      if (timer.childNodes) {
        stepNos.push(1);

        if (timer.loop === 0) {
          timer.loop = LONGEST_LOOP;
        }

        for (var i = timer.loop; i > 0; i--) {
          stepNos[stepNos.length - 1] = timer.loop - i + 1;

          this._convertToPromises(timer.childNodes, callback, results, stepNos);
        }

        stepNos.pop();
      }

      if (timer.timeSec) {
        var displayStepNos = this._convertToDisplayStepNos(stepNos);

        results.push(function () {
          return _this2._createTimer(timer.timeSec, callback, displayStepNos);
        });
      }

      this._convertToPromises(ast, callback, results, stepNos);
    }
  }, {
    key: "_convertToDisplayStepNos",
    value: function _convertToDisplayStepNos(stepNos) {
      var result = '';

      if (stepNos.length > 0) {
        var _iterator2 = _createForOfIteratorHelper(stepNos.entries()),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var _step2$value = _slicedToArray(_step2.value, 2),
                i = _step2$value[0],
                stepNo = _step2$value[1];

            result += stepNo;

            if (i + 1 < stepNos.length) {
              result += '-';
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }

      return result;
    }
  }, {
    key: "_createTimer",
    value: function _createTimer(timeSec, callbacks, stepNos) {
      var _this3 = this;

      return new Promise(function (resolve) {
        var remainingSec = timeSec;
        _this3._interval = setInterval(function () {
          if (_this3._isPaused) return;
          callbacks.interval(--remainingSec, timeSec, stepNos);

          if (remainingSec <= 0) {
            clearInterval(_this3._interval);
            _this3._interval = null;
            resolve();
          }
        }, 1000);
      });
    }
  }, {
    key: "_clearTimer",
    value: function _clearTimer() {
      clearInterval(this._interval);
      this._interval = null;
      this._isPaused = false;
    }
  }, {
    key: "stopTimer",
    value: function stopTimer() {
      if (this._runningPtext == null) return;
      this._runningPtext = null;

      this._clearTimer();

      this._callbacks.cancel && this._callbacks.cancel();
    }
  }, {
    key: "retryLatest",
    value: function retryLatest() {
      var _this4 = this;

      if (!this._runningPtext) return;

      this._clearTimer();

      this._callbacks.start && this._callbacks.start(this._runningPtext);

      this._startTimer(this._runningPtext.ast, this._timerCallbacks).then(function () {
        return _this4._callbacks.finish && _this4._callbacks.finish(_this4._runningPtext);
      });

      if (this._runningPtext.operator === '-') {
        this._isPaused = true;
      }
    }
  }]);

  return Core;
}();

exports.default = Core;